summaryrefslogtreecommitdiffstats
path: root/rfc.sh
diff options
context:
space:
mode:
authorBala.FA <barumuga@redhat.com>2014-03-07 18:28:09 +0530
committerBala.FA <barumuga@redhat.com>2014-04-29 10:14:32 +0530
commit2977b2f34bdbb7284bcc6244e85a1fdb657447f2 (patch)
tree5e1e49207287b7ed8bddaefa5c6b58d07207ebc0 /rfc.sh
parent4e1a40a920e6b2ee1be9f51b0f2a2f875ca790d3 (diff)
Initial commitv0.1.0
Change-Id: I45f91b2017ed59b057d21de52fd94c5c83fcf86f Signed-off-by: Bala.FA <barumuga@redhat.com>
Diffstat (limited to 'rfc.sh')
-rwxr-xr-xrfc.sh114
1 files changed, 114 insertions, 0 deletions
diff --git a/rfc.sh b/rfc.sh
new file mode 100755
index 0000000..fdb22ef
--- /dev/null
+++ b/rfc.sh
@@ -0,0 +1,114 @@
+#!/bin/sh -e
+
+
+branch="master";
+
+
+set_hooks_commit_msg()
+{
+ f=".git/hooks/commit-msg";
+ u="https://10.70.35.186:8443/tools/hooks/commit-msg";
+
+ if [ -x "$f" ]; then
+ return;
+ fi
+
+ curl -k -o $f $u || wget --no-check-certificate -O $f $u;
+
+ chmod +x .git/hooks/commit-msg;
+
+ # Let the 'Change-Id: ' header get assigned on first run of rfc.sh
+ GIT_EDITOR=true git commit --amend;
+}
+
+
+is_num()
+{
+ local num;
+
+ num="$1";
+
+ [ -z "$(echo $num | sed -e 's/[0-9]//g')" ]
+}
+
+
+rebase_changes()
+{
+ git fetch origin;
+
+ GIT_EDITOR=$0 git rebase -i origin/$branch;
+}
+
+
+editor_mode()
+{
+ if [ $(basename "$1") = "git-rebase-todo" ]; then
+ sed 's/^pick /reword /g' "$1" > $1.new && mv $1.new $1;
+ return;
+ fi
+
+ if [ $(basename "$1") = "COMMIT_EDITMSG" ]; then
+ if grep -qi '^BUG: ' $1; then
+ return;
+ fi
+ while true; do
+ echo Commit: "\"$(head -n 1 $1)\""
+ echo -n "Enter Bug ID: "
+ read bug
+ if [ -z "$bug" ]; then
+ return;
+ fi
+ if ! is_num "$bug"; then
+ echo "Invalid Bug ID ($bug)!!!";
+ continue;
+ fi
+
+ sed "/^Change-Id:/{p; s/^.*$/BUG: $bug/;}" $1 > $1.new && \
+ mv $1.new $1;
+ return;
+ done
+ fi
+
+ cat <<EOF
+$0 - editor_mode called on unrecognized file $1 with content:
+$(cat $1)
+EOF
+ return 1;
+}
+
+
+assert_diverge()
+{
+ git diff origin/$branch..HEAD | grep -q .;
+}
+
+
+main()
+{
+ set_hooks_commit_msg;
+
+ if [ -e "$1" ]; then
+ editor_mode "$@";
+ return;
+ fi
+
+ rebase_changes;
+
+ assert_diverge;
+
+ bug=$(git show --format='%b' | grep -i '^BUG: ' | awk '{print $2}');
+
+ if [ "$DRY_RUN" = 1 ]; then
+ drier='echo -e Please use the following command to send your commits to review:\n\n'
+ else
+ drier=
+ fi
+
+ if [ -z "$bug" ]; then
+ $drier git push origin HEAD:refs/for/$branch/rfc;
+ else
+ $drier git push origin HEAD:refs/for/$branch/bug-$bug;
+ fi
+}
+
+main "$@"